"
 COPYRIGHT (c) 1992-93 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

ImageReader subclass:#XBMReader
         instanceVariableNames:''
         classVariableNames:'reverseBits'
         poolDictionaries:''
         category:'Graphics-Support'
!

XBMReader comment:'

COPYRIGHT (c) 1992-93 by Claus Gittinger
              All Rights Reserved

this class provides methods for loading and saving xbitmap-file pictures.

%W% %E%
written Sep 92 by claus
'!

!XBMReader methodsFor:'reading from file'!

fromFile:aFileName
    |line 
     index    "{ Class: SmallInteger }"
     dstIndex "{ Class: SmallInteger }"
     bytesPerRow
     lo       "{ Class: SmallInteger }"
     hi       "{ Class: SmallInteger }"
     val      "{ Class: SmallInteger }"|

    inStream := FileStream readonlyFileNamed:aFileName.
    inStream isNil ifTrue:[
        'open error' printNewline.
        ^ nil
    ].

    line := inStream nextLine.
    line isNil ifTrue:[
        inStream close.
        ^ nil
    ].

    [line startsWith:'#'] whileFalse:[
        line := inStream nextLine
    ].

    index := line indexOf:(Character space).
    index := line indexOf:(Character space) startingAt:(index + 1).
    (index == 0) ifTrue:[
        'format error' prrintNewline.
        inStream close.
        ^ nil
    ].
    line := line copyFrom:(index + 1).
    width := Number readFromString:line.

    line := inStream nextLine.
    index := line indexOf:(Character space).
    index := line indexOf:(Character space) startingAt:(index + 1).
    (index == 0) ifTrue:[
        'format error' prrintNewline.
        inStream close.
        ^ nil
    ].
    line := line copyFrom:(index + 1).
    height := Number readFromString:line.

    bytesPerRow := width // 8.
    ((width \\ 8) ~~ 0) ifTrue:[
        bytesPerRow := bytesPerRow + 1
    ].

    reverseBits isNil ifTrue:[
        reverseBits := ByteArray new:256.
        0 to:255 do:[:i |
            val := 0.
            index := i.
            (index bitTest:16r01) ifTrue:[val := val bitOr:16r80].
            (index bitTest:16r02) ifTrue:[val := val bitOr:16r40].
            (index bitTest:16r04) ifTrue:[val := val bitOr:16r20].
            (index bitTest:16r08) ifTrue:[val := val bitOr:16r10].
            (index bitTest:16r10) ifTrue:[val := val bitOr:16r08].
            (index bitTest:16r20) ifTrue:[val := val bitOr:16r04].
            (index bitTest:16r40) ifTrue:[val := val bitOr:16r02].
            (index bitTest:16r80) ifTrue:[val := val bitOr:16r01].
            reverseBits at:(index + 1) put:val
        ]
    ].

    data := ByteArray new:(bytesPerRow * height).
    dstIndex := 1.

    line := inStream nextLine.
    [line startsWith:'#'] whileTrue:[
        line := inStream nextLine
    ].

    line := inStream nextLine.
    [line notNil] whileTrue:[
        index := 1.
        [index ~~ 0] whileTrue:[
            index := line indexOf:$x startingAt:index.
            (index ~~ 0) ifTrue:[
                index := index + 1.
                hi := (line at:index) digitValue.
                index := index + 1.
                lo := (line at:index) digitValue.
                val := (hi bitShift:4) bitOr:lo.
                data at:dstIndex put:(reverseBits at:(val + 1)).
                dstIndex := dstIndex + 1
            ]
        ].
        line := inStream nextLine
    ].
    photometric := #whiteIs0.
    samplesPerPixel := 1.
    bitsPerSample := #(1)

    "XBMReader fromFile:'bitmaps/globe1.xbm'" 
! !
